% 01 juillet 2020
% manuel.luque27@gmail.com
/pst-campylograph {
25 dict begin
/m exch def
/Z0 exch def % roue entranante
% satellites
/Z1 exch def
/Z2 exch def
/Z3 exch def
/Z4 exch def
% les phases
/Ph4 exch def
/Ph3 exch def
/Ph2 exch def
/Ph1 exch def
% distance du point sur la roue au centre
/r4 exch def
/r3 exch def
/r2 exch def
/r1 exch def
% angle rotation
/tmax exch def
% rayon des roues
/R0 Z0 m mul 2 div def
/R1 Z1 m mul 2 div def
/R2 Z2 m mul 2 div def
/R3 Z3 m mul 2 div def
/R4 Z4 m mul 2 div def
/alpha 45 def
/xC1 R1 R0 add alpha cos mul def
/yC1 R1 R0 add alpha sin mul def
/xC2 R2 R0 add alpha 90 add cos mul def
/yC2 R2 R0 add alpha 90 add sin mul def
/xC3 R3 R0 add alpha 180 add cos mul def
/yC3 R3 R0 add alpha 180 add sin mul def
/xC4 R4 R0 add alpha 270 add cos mul def
/yC4 R4 R0 add alpha 270 add sin mul def
/w0 1 def % rotation en sens inverse des satellites
/w1 Z0 Z1 div def
/w2 Z0 Z2 div def
/w3 Z0 Z3 div def
/w4 Z0 Z4 div def
/Ltige1 xC1 xC3 sub dup mul yC1 yC3 sub dup mul add sqrt def
/Ltige2 xC2 xC4 sub dup mul yC2 yC4 sub dup mul add sqrt def
/Ltige Ltige1 Ltige2 max 1 r3 add r2 r4 add max 1.05 mul add def
/Lrainure Ltige 0.05 mul def
/Div { dup 0 eq { pop } { div } ifelse } def  	% control the division
%
/Pixel{
2 dict begin
/y exch cm def /x exch cm def
x y Ep 4 div cm 0 360 arc fill
end
} def
%
/Rotation {
2 dict begin
/y exch def
/x exch def
/W w0 t mul neg def
x W cos mul y W sin mul add %
x W sin mul neg y W cos mul add %
end
} def
%
% les roues sont disposes  45 degrs les unes des autres
% A1(3) et A2(4) diamtralment opposes
/CalculsCampylograph {
/t exch def
/x1 r1 w1 t mul Ph1 add cos mul xC1 add def
/y1 r1 w1 t mul Ph1 add sin mul yC1 add def
/x3 r3 w3 t mul Ph3 add cos mul xC3 add def
/y3 r3 w3 t mul Ph3 add sin mul yC3 add def
/x2 r2 w2 t mul Ph2 add cos mul xC2 add def
/y2 r2 w2 t mul Ph2 add sin mul yC2 add def
/x4 r4 w4 t mul Ph4 add cos mul xC4 add def
/y4 r4 w4 t mul Ph4 add sin mul yC4 add def
/a1 y3 y1 sub x3 x1 sub Div def
/b1 y1 a1 x1 mul sub def
/a2 y4 y2 sub x4 x2 sub Div def
/b2 y2 a2 x2 mul sub def
% intersection de (A1A2) et (A3A4)
/xI b2 b1 sub a2 a1 sub Div neg def
/yI a1 xI mul b1 add def
xI yI
FixedPlate {}{Rotation} ifelse
} def
%
/DessinTigesCampylographe {
% les extrmit des la tige
/yE exch def /xE exch def
/yF exch def /xF exch def
/alpha yF yE sub xF xE sub atan def
% epaisseur de la tige
/Ep 0.35 def
/UneTige {
newpath
Ltige cm Ep -2 div cm moveto
0 cm Ep -2 div cm lineto
0 0 Ep 2 div cm -90 90 arcn
0 Ep 2 div cm lineto
Ltige cm Ep 2 div cm lineto
Ltige cm Ep 4 div cm lineto
Lrainure cm Ep 4 div cm lineto
Lrainure cm Ep -4 div cm lineto
Ltige cm Ep -4 div cm lineto
closepath
} def
gsave
0.5 0.5 0 setrgbcolor
xE cm yE cm translate
alpha rotate
UneTige
fill
0 setgray
UneTige
stroke
grestore
} def
%%% r4 r3 r2 r1 Ph4 Ph3 Ph2 Ph1 Z4 Z3 Z2 Z1 Z0 m ConfigurationCampylograph %%%
/Coords [
0 1 tmax{
CalculsCampylograph
} for
 ] def
gsave
curvecolor
curvewidth
FixedPlate {}{tmax neg rotate} ifelse
Coords 0 get cm Coords 1 get cm moveto
0 2 Coords length 2 sub {/i exch def
Coords i get cm Coords i 1 add get cm lineto
} for
stroke
grestore
CampylographDrawing {
tmax CalculsCampylograph
gsave
0.7 1 0.7 setrgbcolor
xC1 cm yC1 cm r1 1.1 mul cm 0 360 arc FILL
xC2 cm yC2 cm r2 1.1 mul cm 0 360 arc FILL
xC3 cm yC3 cm r3 1.1 mul cm 0 360 arc FILL
xC4 cm yC4 cm r4 1.1 mul cm 0 360 arc FILL
0 setgray
xC1 cm yC1 cm r1 1.1 mul cm 0 360 arc stroke
xC2 cm yC2 cm r2 1.1 mul cm 0 360 arc stroke
xC3 cm yC3 cm r3 1.1 mul cm 0 360 arc stroke
xC4 cm yC4 cm r4 1.1 mul cm 0 360 arc stroke
grestore
%x1 cm y1 cm moveto
%x3 cm y3 cm lineto
%x2 cm y2 cm moveto
%x4 cm y4 cm lineto
%stroke
x3 y3 x1 y1 DessinTigesCampylographe
x4 y4 x2 y2 DessinTigesCampylographe
%
x1 y1 Pixel
x2 y2 Pixel
x3 y3 Pixel
x4 y4 Pixel
curvecolor
xI yI Pixel
} if
end
} def
